
{    This code allows multiple propeller chips to comunicate over only two ports pins each.

  as written, it allows three Propeller chips A, B, and C on a single circuit board to communicate with each
  other,  but could easily be modified for several more processors.

  With proper isolation, multiple Props could easily be linked at a distance.  Fiber optics would be nice.

  The essence is that a 196 bit block of data is filled by each processor in it's own turn.
  This requires that each processor "KNOW" it's position in the sequence and be programed with a slightly
  different version of the code, but tanstaafl.  ( there ain't no such thing as a free lunch ) 

  each processor has it's own block 64 bits of data that it may write to in turn
  as well as "Listen" to the data as each other two Propellers write their own block.

  it was wastful of memory, but each data byte is a "Bit" and is either a 1 or a 0
  ( this could easily be done with 6 longs and bit shifting, instead of the 50 used here but I was lazy )

  As the first 64 clock pulses come in, processor A either pulls the data line low or leaves it high
  to send it's data while the other two processors "Listen"  reading the highs or lows.
  at the 65th clock, processor B starts sending it's data.
  and 129th clock, processor C sends its data.


  

  There is no reason these blocks need to be this particular size and could easily be modified to send
   more or less data as needed.

   These 64 bit blocks can be anything you want.  Flags, to indicate what is going on in another processor,
   Data from a sensor, Communication from an outside source, etc.
   likewise, the data in these blocks could easily have check-bits/bytes to ensure that the block
   is "intact" as recieved.   ( I highly recommend this for processors linked at a distance )
   

   This code was written in spin. It isn't very fast and hasn't been optimized for speed
   or memory space but it worked fine for my particular aplication.

   As a USEFUL object for others,   I would highly recommend someone take the time to clean this up,

   In particular,
   1. bit shifting instead of using whole bytes to represent a bit.  ( this would get rid of
      some of the awkwareness of bit to byte data coding/decoding,  as well as saving memory )

   2. Adding parity encoding/chcecking

   3. adding signal "Noise" detection ( checking the data line 3-5 times to average the signal )   

    If anyone wants to take the code further, please do!

   it could EASILY be improved but the basic concept works.


   
   I was only using two of the three processors on this board so I eventually switched over to use the
   admittedly better full-duplex RS-232 function.  But anyone interested in connecting three or more
   Propellers might consider something that starts out along these lines.  
  
  This sort of multi-processor communication function could probably be done with a single pin in the
   same way without the separate "Clock" line, 
   but having  three propellers on the same board, I had plenty of I/O's and wasn't worried about optimization
   

    if re-written to operate on a single pin,
    a master would generate a low sync pulse on the data pin, and all processors on the "Bus"
   would be responsible for using the length of this pulse to determine their own time-frame for
   "Listening" to the other processors and sending their data at the proper time. 

     
   

  the operation of THIS code is as follows:

  The two pins are clock and data.  Both of these "Bus" pins are hooked to a 1K pullup.
  

  Each propeller has two pins connected to this two wire  "Bus"  

   
  one propeller is selected as the "Master"  it controls the clock signal.  This clock function is
  generated by a seperate cog running nothing but the clock generation program. ( with 24 cogs
  on a single board, I wasn't worried about it.  ) 

  The Master pulls the clock line low for a period of time to let all the processors on the bus
  know the block transmission is about to start. When the clock line goes high again, each processor
  takes it's own turn listening to the others or sending it's own data.


  

 as I write this, I'm snowed in by the 2011 blizzard and don't have access to the 3 processor board this was
 originally written for.  The clock code is on another computer at my office, so I put something together
 I THINK might work.
 
 I only guarentee that it DID work at one point in time, not that this particular code works.
 I'll be reviving one of these boards soon and will put something together that I KNOW functions,
 but I thought I would throw this code out for anyone that wants to play with it. 
 
 
   

' com. function

' this function is intended to run independently of the main program handling only
' inter-processor communication
' alfacom2  E-stop ( d_54 ) check and set added to this function to insure all processors
' have access to stop flag data
}

Con
    datapin  =    8        
    clockpin =    10
 
     clocktime =   9
     testpin = 14         ' test pin

     estoppin = 5         ' port connected to the "A" processor Emergency stop input.
      
      d_estop = 54        ' bit defined as the emergency stop bit for all processors listening

      clockdelay = 2000
             
    
Var

    byte data[200]              ' a very inefficent way of storing 196 BITS of data
    long datacount
    long syncheck

    long  cogon, cog                                      ' cog status
    long  comStack[12]                                    ' local stack
                                         ' NOTE***  I have no clue of how to determine a CORRECT stack size.
    long clockstack[12]

PUB start : okay

'' Load background com function if cog available
''  

  stop                                                  ' stop cog for this object if running
  cleardata


 '  setdata

    ' only one processor should "Be the clock"
    cognew( clockit, @clockstack) 

  
  okay := cogon := (cog := cognew(alphacom, @comStack)) > 0


PUB stop

'' Unload timer object - frees a cog

  if cogon~                                             ' if object running, mark stopped
    cogstop(cog)                                        ' stop the cog

 
PUB cleardata

''  clear data registers
  datacount := 0

  repeat 200
   data[datacount] := 0
   datacount ++

   

pub set(position, value)                 ' set data array values

  data[position] := value


pub get(position)  : retval                  ' get data array values

   return data[position]
   


pub clockit        | synctime    ' master clock function

 dira[clockpin] := 1
  synctime := clockdelay * 20   ' give a nice long sync pulse 

  

 repeat

    outa[clockpin] := 0
    waitcnt( cnt + synctime )
    outa[clockpin] := 1
    waitcnt(cnt + clockdelay)
    
    
    repeat 196
    
     outa[clockpin] := 0
     waitcnt(cnt + clockdelay)      
    
      outa[clockpin] := 1
      waitcnt(cnt + clockdelay)
   


Pub alphacom            ' comunication for processor  "A"   (bits 1 - 64)            

    dira[estoppin] := 0    ' set stop to input

    
      repeat

       wait4attn          'wait for the sync pulse           
        
       
       listenandchatA     ' now do all com functions
       
Pub bravocom            ' comunication for processor  "B"               

    dira[estoppin] := 0    ' set stop to input

    
      repeat

       wait4attn          'wait for the sync pulse           
        
       
       listenandchatB     ' now do all com functions
Pub charliecom            ' comunication for processor "C"               

    dira[estoppin] := 0    ' set stop to input

    
      repeat

       wait4attn          'wait for the sync pulse           
        
       
       listenandchatC     ' now do all com functions
     

 
pub listenandchatA       | stopon        ' you just got here from the wait for sync function
                                ' the clock pin should still be high

 dira[testpin] := 1                 ' test pin

  data[d_estop] := 0  
 
   datacount := 0

                 ' I needed to be sure all 3 processors knew when an emergency stop was hit,
                 ' so I added the check here.
                 
    ' check Estop flag each cycle
     stopon := ina[estoppin]
      if stopon == 1      ' estop is hit
         data[d_estop] := 1

    
   ' **************************************   Send 64 processor A data out  **********************************
         
           
    dira[datapin] := 1                         ' set up to be the output guy
    repeat while datacount < 64

    
      outa[datapin] := data[datacount]             ' set the data on the data line

      outa[testpin] := data[datacount]
      

     
        repeat while ina[clockpin] == 1      ' wait here while clock is high

        datacount ++                          ' incriment the counter

        repeat while ina[clockpin] == 0       ' now wait for the clock pin to go high again
        

        ' when the clock goes low, the other processors will take the current data


   dira[datapin] := 0             ' reset the data direction pin to input


       


  
  
    ' **************************************  GET 64 processor b data in **********************************
 

 ' listen 64
 
    repeat  while datacount < 128
    
                  repeat while ina[clockpin] == 1   ' wait here while clock is high
             
                   data[datacount] := ina[datapin]       ' get the data  
                   
                                
       datacount ++                              ' incriment the count

       
              repeat while ina[clockpin] == 0   ' wait for the clock pin to go high
              
       

           ' now send your 64 bits

              
   ' **************************************  listen 64 Processor C data in **********************************
         
 
  
    repeat  while datacount < 196
    
                  repeat while ina[clockpin] == 1   ' wait here while clock is high
         
                   data[datacount] := ina[datapin]   ' get the data 
                               
                                
       datacount ++                              ' incriment the count

       
              repeat while ina[clockpin] == 0   ' wait for the clock pin to go high
              
 


pub listenandchatB       | stopon        ' you just got here from the wait for sync function
                                ' the clock pin should still be high

 dira[testpin] := 1                 ' test pin

  data[d_estop] := 0  
 
   datacount := 0

         
 
    ' **************************************  GET 64 processor A data in **********************************
 

 ' listen 64
 
    repeat  while datacount < 64
    
                  repeat while ina[clockpin] == 1   ' wait here while clock is high
             
                   data[datacount] := ina[datapin]       ' get the data  
                   
                                
       datacount ++                              ' incriment the count

       
              repeat while ina[clockpin] == 0   ' wait for the clock pin to go high
              
    
   ' **************************************   Send 64 processor B data bits out  **********************************
 
        
           
    dira[datapin] := 1                         ' set up to be the output guy
    repeat while datacount < 128

    
      outa[datapin] := data[datacount]             ' set the data on the data line

      outa[testpin] := data[datacount]
      

     
        repeat while ina[clockpin] == 1      ' wait here while clock is high

        datacount ++                          ' incriment the counter

        repeat while ina[clockpin] == 0       ' now wait for the clock pin to go high again
        

        ' when the clock goes low, the other processors will take the current data


   dira[datapin] := 0             ' reset the data direction pin to input


       


  
              
   ' *******************************  listen 64 bits Processor C data in **********************************
         
 
  
    repeat  while datacount < 196
    
                  repeat while ina[clockpin] == 1   ' wait here while clock is high
         
                   data[datacount] := ina[datapin]   ' get the data 
                               
                                
       datacount ++                              ' incriment the count

       
              repeat while ina[clockpin] == 0   ' wait for the clock pin to go high
              
 

pub listenandchatC       | stopon        ' you just got here from the wait for sync function
                                ' the clock pin should still be high

 dira[testpin] := 1                 ' test pin

  data[d_estop] := 0  
 
   datacount := 0

         
 
    ' **************************************  GET 64 processor A data bits in **********************************
 

 ' listen 64
 
    repeat  while datacount < 64
    
                  repeat while ina[clockpin] == 1   ' wait here while clock is high
             
                   data[datacount] := ina[datapin]       ' get the data  
                   
                                
       datacount ++                              ' incriment the count

       
              repeat while ina[clockpin] == 0   ' wait for the clock pin to go high




              
   ' *******************************  listen 64 bits Processor B data in **********************************
         
 
  
    repeat  while datacount < 128
    
                  repeat while ina[clockpin] == 1   ' wait here while clock is high
         
                   data[datacount] := ina[datapin]   ' get the data 
                               
                                
       datacount ++                              ' incriment the count

       
              repeat while ina[clockpin] == 0   ' wait for the clock pin to go high      
              
              
    
   ' **************************************   Send 64 processor C data bits out  **********************************
 
        
           
    dira[datapin] := 1                         ' set up to be the output guy
    repeat while datacount < 196     
    
      outa[datapin] := data[datacount]             ' set the data on the data line

      outa[testpin] := data[datacount]  
     
        repeat while ina[clockpin] == 1      ' wait here while clock is high

        datacount ++                          ' incriment the counter

        repeat while ina[clockpin] == 0       ' now wait for the clock pin to go high again
        

        ' when the clock goes low, the other processors will take the current data


   dira[datapin] := 0             ' reset the data direction pin to input


       


  
 


      

pub wait4attn            ' wait for sync pulse
   
    
 datacount  := 0

 syncheck := clocktime / 3    ' check for clock on/off and use an odd timeing value based on clock frequency
 
  repeat  while datacount < 10

    
          if ina[clockpin] == 1         ' if you get a clock pulse high, rezero the count
             datacount := 0
             
          'add the current 1 value to the count      
          datacount ++ 
          repeat syncheck ' now delay for a short time 
        


  ' you fell through to here.  the sync pulse must now be low

  ' now wait till the clock pin goes high

  repeat while ina[clockpin] == 0
  


 
pub  clrdataword  | indx            ' clear the 16  bit data word to zeros
 indx:= 32

     repeat

        data[indx] := 0
        indx++
     while indx<48   

pub setsign(tmp)                     ' set the sign value ( 17th bit ) of the transmission packet
   if tmp == 1
        data[48] := 1
   else
        data[48] := 0
              
pub setdataword(tmp)               ' set the data transmission bits given a word value

        clrdataword
                                         
        if  tmp & %1
             data[32] :=1                                         
        if  tmp & %10
             data[33] :=1  
        if  tmp & %100
             data[34] :=1                                        
        if  tmp & %1000
             data[35] :=1  
        if  tmp & %10000
             data[36] :=1                                         
        if  tmp & %100000
             data[37] :=1  
        if  tmp & %1000000
             data[38] :=1   
        if  tmp & %10000000
             data[39] :=1    
        if  tmp & %100000000
             data[40] :=1    
        if  tmp & %1000000000
             data[41] :=1     
        if  tmp & %10000000000
             data[42] :=1      
        if  tmp & %100000000000
             data[43] :=1     
        if  tmp & %1000000000000
             data[44] :=1      
        if  tmp & %10000000000000
             data[45] :=1        
        if  tmp & %100000000000000
             data[46] :=1        
        if  tmp & %1000000000000000
             data[47] :=1




 

pub setdata                    ' ( this was a test function ) 
  data[5] := 1
  data[10] := 1
  data[20] := 1
   data[30] := 1
   data[40] := 1
   data[50] := 1
                     